SystemOrganization addCategory: #'Glamour-Browsers'!

GLMExplicitBrowser subclass: #GLMStacker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMStacker commentStamp: '<historical>' prior: 0!
A GLMStacker is an explicit browser that allows us to stack panes on top of each other and show them as tabs.!

!GLMStacker methodsFor: 'as yet unclassified' stamp: 'tg 6/12/2010 14:21'!
aPane: aBlockOrSymbol
	^ self addNewPaneNamed: aBlockOrSymbol! !

!GLMStacker methodsFor: 'as yet unclassified' stamp: 'tg 6/12/2010 14:18'!
renderGlamorouslyOn: aRenderer 
	^aRenderer renderStacker: self! !

GLMExplicitBrowser subclass: #GLMTabulator
	instanceVariableNames: 'cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMTabulator commentStamp: '<historical>' prior: 0!
A GLMTabulator is an explicit browser that allows us to place panes in columns and rows.!

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addColumn: aBlockOrSymbol 
	 
	^self cellOrRow addColumn: aBlockOrSymbol! !

!GLMTabulator methodsFor: 'layout' stamp: 'tg 10/22/2009 13:27'!
addColumn: aBlockOrSymbol size: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) size: anInteger; span: 0! !

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addColumn: aBlockOrSymbol span: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) span: anInteger! !

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addRow: aBlockOrSymbol 
	 
	^self cellOrColumn addRow: aBlockOrSymbol! !

!GLMTabulator methodsFor: 'layout' stamp: 'tg 10/22/2009 13:27'!
addRow: aBlockOrSymbol size: anInteger 
	 
	^(self addRow: aBlockOrSymbol) size: anInteger; span: 0! !

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addRow: aBlockOrSymbol span: anInteger 
	 
	^(self addRow: aBlockOrSymbol) span: anInteger! !

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
cell 
	 
	^cell! !

!GLMTabulator methodsFor: 'private' stamp: ' 4/5/09 22:18'!
cellOrColumn 
	 
	^cell ifNil: [cell := GLMCustomColumn new browser: self]! !

!GLMTabulator methodsFor: 'private' stamp: ' 4/5/09 22:18'!
cellOrRow 
	 
	^cell ifNil: [cell := GLMCustomRow new browser: self]! !

!GLMTabulator methodsFor: 'rendering' stamp: 'tg 1/10/2010 16:20'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderTabulator: self! !

Announcement subclass: #GLMPaneAnnouncement
	instanceVariableNames: 'pane browser position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneAnnouncement commentStamp: 'TudorGirba 2/4/2011 21:24' prior: 0!
These announcements are used by the browser to communicate with the renderer whenever the panes configuration is modified in some way.

Instance Variables:
	pane	<GLMPane>
	browser	<GLMBrowser>
	position	<Integer>!

GLMPaneAnnouncement subclass: #GLMPaneAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneAnnouncement classSide methodsFor: 'instance creation' stamp: 'tg 1/18/2010 11:08'!
pane: aPane atPosition: anInteger inBrowser: aBrowser 
	 
	^(self new) 
		pane: aPane; 
		position: anInteger; 
		browser: aBrowser; 
		yourself! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
browser 
	 
	^browser! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
browser: anObject 
	 
	browser := anObject! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
pane 
	 
	^pane! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
pane: anObject 
	 
	pane := anObject! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
position 
	 
	^position! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
position: anObject 
	 
	position := anObject! !

GLMPaneAnnouncement subclass: #GLMPaneRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneRemoved classSide methodsFor: 'instance creation' stamp: ' 4/5/09 22:18'!
pane: aPane fromBrowser: aBrowser 
	 
	^(self new) 
		pane: aPane; 
		browser: aBrowser; 
		yourself! !

GLMPaneAnnouncement subclass: #GLMPaneReplaced
	instanceVariableNames: 'oldPane newPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneReplaced classSide methodsFor: 'as yet unclassified' stamp: 'tg 8/22/2010 21:35'!
oldPane: oldPane newPane: newPane fromBrowser: aBrowser
	^ self new 
		oldPane: oldPane;
		newPane: newPane;
		browser: aBrowser! !

!GLMPaneReplaced methodsFor: 'accessing' stamp: 'tg 8/22/2010 21:36'!
newPane
	^ newPane! !

!GLMPaneReplaced methodsFor: 'accessing' stamp: 'tg 8/22/2010 21:36'!
newPane: anObject
	newPane := anObject! !

!GLMPaneReplaced methodsFor: 'accessing' stamp: 'tg 8/22/2010 21:36'!
oldPane
	^ oldPane! !

!GLMPaneReplaced methodsFor: 'accessing' stamp: 'tg 8/22/2010 21:36'!
oldPane: anObject
	oldPane := anObject! !

GLMPaneAnnouncement subclass: #GLMPaneSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

GLMImplicitBrowser subclass: #GLMAccumulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMAccumulator commentStamp: 'tg 2/2/2010 21:32' prior: 0!
An GLMAccumulator is an implicit type of browser that has the following behavior:
- each input entity has associated a pane without any relationship with the other panes
- based on the input entity if there already exists a pane associated, it is selected via GLMPaneSelected
- if there isnt a pane, a new pane is created
- based on entityToSelect, the associated pane is searched and potentially selected
- when a pane is selected in the user interface, the activeEntity is populated with the entity behind the selected pane

Input ports:
- entity
- entityToSelect

Output ports:
- selection
- activeEntity!

!GLMAccumulator methodsFor: 'accessing ports' stamp: 'tg 2/2/2010 22:03'!
activeEntity
	^ (self pane port: #activeEntity) value! !

!GLMAccumulator methodsFor: 'accessing ports' stamp: 'tg 2/2/2010 21:31'!
activeEntity: anObject
	^ (self pane port: #activeEntity) value: anObject ! !

!GLMAccumulator methodsFor: 'private' stamp: 'tg 8/22/2010 17:59'!
addPaneFrom: aPort 
	aPort value isNil ifTrue: [ ^ self ].
	(self tryToSelectPaneFrom: aPort) ifTrue: [ ^ self ].
	self panes addLast: (GLMPane in: self).
	GLMTransmission new
		ensureBundleStrategy;
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		presentations: (self presentations copy); 
		transmit.
	self announce: 
			(GLMPaneAdded 
				pane: self panes last 
				atPosition: self panes size 
				inBrowser: self)! !

!GLMAccumulator methodsFor: 'accessing ports' stamp: 'tg 2/2/2010 22:00'!
entityToSelect
	^ (self pane port: #entityToSelect) value! !

!GLMAccumulator methodsFor: 'accessing ports' stamp: 'tg 1/19/2010 21:24'!
entityToSelect: anObject
	^ (self pane port: #entityToSelect) value: anObject ! !

!GLMAccumulator methodsFor: 'events' stamp: 'tg 1/18/2010 07:47'!
innerPortEvent: aPortEvent 
	aPortEvent portName = #entity ifFalse: [
		"We don't want to resend the transmission, but use a new SimpleTransmission." 
		(self pane port: aPortEvent portName) value: aPortEvent value]! !

!GLMAccumulator methodsFor: 'events' stamp: 'tg 1/19/2010 21:23'!
outerPortEvent: aPortEvent 
 	super outerPortEvent: aPortEvent.
	aPortEvent port name = #entityToSelect ifTrue: [
		self tryToSelectPaneFrom: aPortEvent port ].	
	aPortEvent port name = #entity ifTrue: [
		self addPaneFrom: aPortEvent port ]! !

!GLMAccumulator methodsFor: 'private' stamp: 'tg 1/31/2010 01:13'!
removePaneIndex: i
	| paneRemoved |
	paneRemoved := self panes removeAt: i.
	paneRemoved unregisterFromAllAnnouncements.
	self announce: (GLMPaneRemoved pane: paneRemoved fromBrowser: self )! !

!GLMAccumulator methodsFor: 'rendering' stamp: 'tg 1/18/2010 08:36'!
renderGlamorouslyOn: aRenderer
	^ aRenderer renderAccumulator: self! !

!GLMAccumulator methodsFor: 'private' stamp: 'tg 1/19/2010 21:50'!
tryToSelectPaneFrom: aPort
	self panes withIndexDo: [:each :i | 
		(each port: #entity) value = aPort value ifTrue: [
			self announce: 
				(GLMPaneSelected 
					pane: each 
					atPosition: i
					inBrowser: self).
			^ true ] ].
	^ false! !

GLMImplicitBrowser subclass: #GLMExpander
	instanceVariableNames: 'rootPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMExpander commentStamp: 'tg 5/1/2010 12:36' prior: 0!
GLMExpander aims to implement a Hopscotch-like browser!

!GLMExpander methodsFor: 'events' stamp: 'TudorGirba 1/2/2011 19:24'!
addPaneFrom: aPort 
	self panes addLast: (GLMPane in: self).
	GLMTransmission new
		ensureBundleStrategy;
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		presentations: (self presentations copy); 
		transmit.
	self announce: 
			(GLMPaneAdded 
				pane: self panes last 
				atPosition: self panes size 
				inBrowser: self)! !

!GLMExpander methodsFor: 'events' stamp: 'TudorGirba 1/9/2011 01:46'!
innerPortEvent: aPortEvent 
	 
	aPortEvent portName = #entity ifFalse: [
		"We resend the value to the outer pane"
		"We don't want to resend the transmission, but use a new SimpleTransmission." 
		(self pane port: aPortEvent portName) value: aPortEvent value]! !

!GLMExpander methodsFor: 'events' stamp: 'TudorGirba 1/9/2011 01:34'!
outerPortEvent: aPortEvent 
	 
	aPortEvent port name = #entity ifFalse: [^self]. 
	panes := nil. 
	self matches ifTrue: [
		"We only want to execute the transformation if the visibility condition matches"
		(self transformation glamourValue: aPortEvent port value) do: [:each |
			self addPaneFrom: (GLMSimplePort new value: each) ] ]! !

!GLMExpander methodsFor: 'rendering' stamp: 'TudorGirba 1/2/2011 18:59'!
renderGlamorouslyOn: aRenderer 
	^ aRenderer renderExpander: self! !

GLMImplicitBrowser subclass: #GLMFinder
	instanceVariableNames: 'hasFixedSizePanes fixedSizePanes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMFinder commentStamp: 'tg 1/26/2010 12:41' prior: 0!
A GLMFinder models a browsers that behaves like the Mac Finder: whenever the selection port is set on one pane, a new one is created to the right with the selection as entity. The Finder opens the first pane on the entity.

Input ports:
- entity: this is passed to the first pane

Output ports:
- selection: this port is populated with the value from the last selection port from one of the panes!

!GLMFinder methodsFor: 'private' stamp: 'TudorGirba 1/18/2011 14:35'!
addPaneFrom: aPort 
	self panes addLast: (GLMPane in: self).
	GLMTransmission new
		ensureBundleStrategy;
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		presentations: (self presentations copy); 
		transmit! !

!GLMFinder methodsFor: 'private' stamp: 'tg 10/27/2010 12:21'!
addPaneFromInner: aPort 
	| newTransmission realTransmissions lastActivePresentation |
	"the lastActivePresentation is needed for knowing what presentation to show by default"
	self panes isEmpty ifFalse: [lastActivePresentation := self panes last lastActivePresentation ].
	self panes addLast: ( (GLMPane in: self) lastActivePresentation: lastActivePresentation; yourself).
	GLMTransmission new
		ensureBundleStrategy;
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		presentations: (self presentations copy); 
		transmit. 
	realTransmissions := self transmissions collect: [:each |  
			newTransmission := GLMTransmission new ensureBundleStrategy. 
			each activeOrigins do: [:eachPort | 
				newTransmission addActiveOrigin: (aPort pane port: eachPort name)]. 
			each passiveOrigins do: [:eachPort | 
				newTransmission addPassiveOrigin: (aPort pane port: eachPort name)]. 
			newTransmission 
				destination: (self panes last port: #entity); 
				addPresentations: (self presentations collect: #copy);
				addPresentations: (each presentations collect: #copy)] . 
	(realTransmissions select: [:each | each originatesAt: aPort]) 
		do: [:each | each transmit]. ! !

!GLMFinder methodsFor: 'accessing' stamp: 'TudorGirba 1/26/2011 10:59'!
hasFixedSizePanes
	^ hasFixedSizePanes ifNil: [hasFixedSizePanes := true]! !

!GLMFinder methodsFor: 'accessing' stamp: 'TudorGirba 1/26/2011 10:59'!
hasFixedSizePanes: aBoolean
	hasFixedSizePanes := aBoolean! !

!GLMFinder methodsFor: 'events' stamp: 'tg 9/13/2010 19:25'!
innerPortEvent: aPortEvent 
	aPortEvent portName = #entity ifFalse: [
		"We don't want to resend the transmission, but use a new SimpleTransmission." 
		(self pane port: aPortEvent portName) value: aPortEvent value]. 

	aPortEvent port name = #selection ifTrue: [
		| index toReplace |
		index := self panes reversed indexOf: aPortEvent pane.
		(self panes reversed first: index - 2) do: [ :each |  
			self removeLastPane.
			self announce: (GLMPaneRemoved pane: each fromBrowser: self) ].
		index <= 1 
			ifTrue: [ 
				self addPaneFromInner: aPortEvent port.
				self announce: 
					(GLMPaneAdded 
						pane: self panes last 
						atPosition: self panes size 
						inBrowser: self) ]
			ifFalse: [
				toReplace := self removeLastPane.
				self addPaneFromInner: aPortEvent port.
				self announce: (GLMPaneReplaced 
							oldPane: toReplace 
							newPane: self panes last
							fromBrowser: self ) ] 
	]! !

!GLMFinder methodsFor: 'events' stamp: 'TudorGirba 1/18/2011 14:35'!
outerPortEvent: aPortEvent 
	 
	| toReplace |
	aPortEvent port name = #entity ifFalse: [^self]. 
	self panes isEmpty
		ifFalse: [
			toReplace := self panes first.
			"self removeAllPanes."
			panes := nil.
			self addPaneFrom: aPortEvent port.
			self announce: (GLMPaneReplaced 
						oldPane: toReplace 
						newPane: self panes first
						fromBrowser: self ) ]
		ifTrue: [
			self addPaneFrom: aPortEvent port.
			self announce: 
				(GLMPaneAdded 
					pane: self panes last 
					atPosition: self panes size 
					inBrowser: self)]! !

!GLMFinder methodsFor: 'rendering' stamp: 'TudorGirba 1/2/2011 18:59'!
renderGlamorouslyOn: aRenderer 
	^ aRenderer renderFinder: self! !

Object subclass: #GLMCustomCell
	instanceVariableNames: 'children span id browser size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser 
	 
	^browser! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser: anObject 
	 
	browser := anObject! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children 
	 
	^children ifNil: [children := OrderedCollection new]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children: anObject 
	 
	children := anObject! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
childrenCount 
	 
	^self children 
		inject: 0 
		into: [:sum :each | sum + each span]! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasId 
	 
	^id notNil! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
id 
	 
	^id ifNil: [#anonymous]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
id: anObject 
	 
	id := anObject! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isColumn 
	 
	^false! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isRow 
	 
	^false! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isSplitIntoColumns 
	 
	^self children allSatisfy: [:each | each isColumn]! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isSplitIntoRows 
	 
	^self children allSatisfy: [:each | each isRow]! !

!GLMCustomCell methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:17'!
size
	^ size ifNil: [0]! !

!GLMCustomCell methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:20'!
size: anObject
	size := anObject.! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
span 
	 
	^span ifNil: [span := 1]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
span: anObject 
	 
	span := anObject! !

GLMCustomCell subclass: #GLMCustomColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomColumn methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:53'!
addRow: aBlockOrSymbol 
	 
	| newRow cell | 
	cell := aBlockOrSymbol isSymbol 
		ifTrue: 
			[self browser 
				addNewPaneNamed: aBlockOrSymbol. 
			(GLMCustomRow new) 
				id: aBlockOrSymbol; 
				browser: self browser] 
		ifFalse: 
			[newRow := GLMCustomRow new browser: self browser. 
			aBlockOrSymbol value: newRow. 
			newRow]. 
	self children addLast: cell. 
	^cell! !

!GLMCustomColumn methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:20'!
addRow: aBlockOrSymbol size: anInteger 
	 
	^(self addRow: aBlockOrSymbol) size: anInteger; span: 0! !

!GLMCustomColumn methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:20'!
addRow: aBlockOrSymbol span: anInteger 
	 
	^(self addRow: aBlockOrSymbol) span: anInteger; size: 0! !

!GLMCustomColumn methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isColumn 
	 
	^true! !

GLMCustomCell subclass: #GLMCustomRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomRow methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:49'!
addColumn: aBlockOrSymbol 
	 
	| newColumn cell | 
	cell := aBlockOrSymbol isSymbol 
		ifTrue: 
			[self browser 
				addNewPaneNamed: aBlockOrSymbol. 
			(GLMCustomColumn new) 
				id: aBlockOrSymbol; 
				browser: self browser] 
		ifFalse: 
			[newColumn := GLMCustomColumn new browser: self browser. 
			aBlockOrSymbol value: newColumn. 
			newColumn]. 
	self children addLast: cell. 
	^cell! !

!GLMCustomRow methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:21'!
addColumn: aBlockOrSymbol size: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) size: anInteger; span: 0! !

!GLMCustomRow methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:21'!
addColumn: aBlockOrSymbol span: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) span: anInteger; size: 0! !

!GLMCustomRow methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isRow 
	 
	^true! !
